document.getElementById("openFileBTN").addEventListener("click", function(event) {
	openFileToForm(event);
}, false);

function openFileToForm(event) {

	switch (pages[curForm].type) {
		case "form":
			pages[curForm].resetForm().then(importFile(event).then(() => {
				//Enable the total calculation listener after the import is finished
				$(".assessment-select").on('change', function(event) {
					calcResults();
				});
				
			}));
			break;

		case "report":
			importFile(event);
			$(".tabulator-cell").on('change', function(event) {
				calcResults();
			});
			break;

	}
}

/** Import JSON File to a form */
var importFile = function(event) {

	return new Promise((resolve, reject) => {
	//Disable the totals calculation until the import is finished
	if (pages[curForm].type === "form") $(".assessment-select").off('change');
	
	var folderSelect = document.getElementById("openFileInput");
	let files = folderSelect.files;
	var json;
		for (var i = 0, f; f = files[i]; i++) {
		var reader = new FileReader();

		// Closure to capture the file information
		reader.onload = (function (theFile) {
			return function (e) {
				try {
					json = JSON.parse(e.target.result);
					switch (pages[curForm].type) {
						case "form":
							//Prevent loading incompatible JSON file
							if (json.formName != pages[curForm].name) throw recuringTrans["wrongFileForPageError"];
							// Binding json object to the template
							// Call our function to get the form data.
							$('#qatSubmit'+pages[curForm].suffix).loadJSON(json);
							calcResults();
							// cal the results after loading
							autosize.update($('textarea'));
							pages[curForm].hasEmptyRequiredFields();
							$('#qatSubmit [name="interviewerAllowToTakeCorrectDecision"],#qatSubmitFid [name="basedOnOverallObservations"]').each(function() {
								var color = getErrorColorConclusion( $(this).val() );
								if(color.length>0){
									$('.conclusion .items:visible').css('background',color);
								}
							  });							
							// fix any textareas
							break;
						case "report":
							reportTable.loadFiltersJSON(json);
							break;
					}
				} catch (ex) {
					alert(recuringTrans["fileLoadError"] +": "+ ex);
				}
			}
		})(f);
		reader.readAsText(f);

	}
	resolve(1);
	});
}

//Encode Image File as BASE64
function encodeImageFileAsURL() {

	var filesSelected = document.getElementById("logoImageInput").files;
	if (filesSelected.length > 0) {
		var fileToLoad = filesSelected[0];

		var fileReader = new FileReader();

		fileReader.onload = function(fileLoadedEvent) {
			var srcData = fileLoadedEvent.target.result; // <--- data: base64

			var newImage = document.createElement('img');
			newImage.src = srcData;

			document.getElementById("logoImagePreview").innerHTML = newImage.outerHTML;
			$("#coverPageMainLogo").val(srcData);
		}
		fileReader.readAsDataURL(fileToLoad);
	}
}